package tallerVehiculos;

import java.time.LocalDate;

public abstract class Vehiculo {
	
	private String placa;
	private String VIN;
	private String marca;
	private String modelo;
	private String anio;
	private String tamanioMotor;
	private String traccion;
	private LocalDate fechaInicio;
	private LocalDate fechaTermino;
	private boolean entregado;
	
	public Vehiculo(String placa, String vIN, String marca, String modelo, String anio, String tamanioMotor,
			String traccion) {
		this.placa = placa;
		VIN = vIN;
		this.marca = marca;
		this.modelo = modelo;
		this.anio = anio;
		this.tamanioMotor = tamanioMotor;
		this.traccion = traccion;
		entregado = false;
	}

	public String getPlaca() {
		return placa;
	}

	public void setPlaca(String placa) {
		this.placa = placa;
	}

	public String getVIN() {
		return VIN;
	}

	public void setVIN(String vIN) {
		VIN = vIN;
	}

	public String getMarca() {
		return marca;
	}

	public void setMarca(String marca) {
		this.marca = marca;
	}

	public String getModelo() {
		return modelo;
	}

	public void setModelo(String modelo) {
		this.modelo = modelo;
	}

	public String getAnio() {
		return anio;
	}

	public void setAnio(String anio) {
		this.anio = anio;
	}

	public String getTamanioMotor() {
		return tamanioMotor;
	}

	public void setTamanioMotor(String tamanioMotor) {
		this.tamanioMotor = tamanioMotor;
	}

	public String getTraccion() {
		return traccion;
	}

	public void setTraccion(String traccion) {
		this.traccion = traccion;
	}

	public void setFechaInicio(LocalDate fechaInicio) {
		this.fechaInicio = fechaInicio;
	}
	
	public String getFechaInicio() {
		if (fechaInicio == null)
			return "No Iniciado";
		else
			return String.format("%d2/%d2/%d4", fechaInicio.getDayOfMonth(),
					fechaInicio.getDayOfMonth(), fechaInicio.getYear());
	}

	public void setFechaTermino(LocalDate fechaTermino) {
		this.fechaTermino = fechaTermino;
	}
	
	public String getFechaTermino() {
		if (fechaTermino == null)
			return "No Terminado";
		else
			return String.format("%d2/%d2/%d4", fechaTermino.getDayOfMonth(),
					fechaTermino.getDayOfMonth(), fechaTermino.getYear());
	}

	public boolean isEntregado() {
		return entregado;
	}

	public void setEntregado(boolean entregado) {
		this.entregado = entregado;
	}
	
	@Override
	/**
	 *Compara dos objetos para saber si son el mismo Vehículo.<br>
	 *Dos Vehículos se consideran el mismo si coincide su atributo VIN. 
	 */
	public boolean equals(Object objeto) {
		if (objeto instanceof Vehiculo) {
			Vehiculo otroVehic = (Vehiculo) objeto;
			return this.VIN.equals(otroVehic.getVIN());
		}
		else
			return false;
	}
	
}
